/**
 * Copyright (c) 2015-2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.microkernel.api.container;

import javax.jbi.JBIException;
import javax.jbi.component.ServiceUnitManager;

/**
 * This class manage the life cycle of deployed service units.
 */
public interface ServiceUnitLifeCycle {

    String getSuName();

    String getTargetComponentName();

    String getServiceUnitRootPath();

    /**
     * Calls {@link ServiceUnitManager#init(String, String)}, but only if the state is correct.
     */
    void init() throws JBIException;

    /**
     * Calls {@link ServiceUnitManager#shutDown(String)}, but only if the state is correct.
     */
    void shutDown() throws JBIException;

    /**
     * Calls {@link ServiceUnitManager#start(String)}, but only if the state is correct.
     */
    void start() throws JBIException;

    /**
     * Calls {@link ServiceUnitManager#stop(String)}, but only if the state is correct.
     */
    void stop() throws JBIException;

}
